Rem Countdownuhr
Rem ************
Rem einstellbar von 1-99 Minuten
Rem S51 stellt Minutenzehner
Rem S52 stellt Minuteneiner
Rem S33 Uhr starten
Rem bei erreichen von 30 sek wird D1 aktiviert
Rem nach ablauf der Zeit wird die letzte
Rem Einstellung angezeigt

rem 27.03.2007

rem (c) Klaus Langenkmper


DEFINE device iL_Troll

Rem Variable

define sekunde= auto as word
define minz= auto as byte              Rem Variable fr die
define mine= auto as byte              '
define sekz= auto as byte              '
define seke= auto as byte              Rem Data Werte
define mz= auto as byte                Rem Variable fr Minutenzehner
define me= auto as byte                '   Minuteneiner
define sz= auto as byte                '   Sekundenzehner
define se= auto as byte                '   Sekundeneiner
define ii= auto as byte                Rem Schleifenvariable
define holdmz= auto as byte            Rem Speichervaraiable fr           
define holdme= auto as byte            '   Minutenzehner/einer
define hv= auto as byte                Rem Hilfsvariable

Rem Init

inp Ra,4                                Rem Taster S33/Start
tris Rb,%00000000                       Rem Datenbus fr 7 Seg via Rb
tris Rc,%00110000                       Rem Rc0-3 schalten die Transistoren
                                        ' Rc4/5 Tastereingang S51/52
                                        ' Rc7 schaltet LED ab 30 sek                                       
let mz=9
let me=9
let sz=0
let se=0
res Rc,7                                   Rem D1 aus
data 1,55,66,18,52,24,8,51,0,16,128,128    Rem Daten fr Rb (0-9) + 2 Dummy
clock sekunde                              Rem Start interner Timer
goto einstellen                            Rem Minutenzehner/einer einstellen

Rem Start

start:

gosub anzeige
if sekunde=1 then goto seg4              Rem Abfrage 1 Sekunde
goto start

Rem Anzeige

anzeige: 

restore                                  Rem Data Zhler auf 1
for ii= 0 to mz                          Rem Schleife bis zum aktuellen
                                         ' Minutenzehnerwert
readdata minz                            Rem Wert lesen fr Rb
next ii
restore
for ii= 0 to me
readdata mine
next ii
restore
for ii= 0 to sz
readdata sekz
next ii
restore
for ii= 0 to se
readdata seke
next ii
output Rb,minz                           Rem Minutenzehnerwert auf Rb ausgeben
res rc,3                                 Rem Transistor einschalten
wait 5                                   Rem warte 5 ms
set rc,3                                 Rem Transistor ausschalten
output Rb,mine
res rc,2
wait 5
set rc,2
output Rb,sekz
res rc,1
wait 5
set rc,1
output Rb,seke
res rc,0
wait 5
set rc,0
return

seg4:

let se=se+1                             ' damit se
dec se                                  
if mz+me+sz+se=0 then goto ende         Rem wenn alle Anzeigen =0 dann weiter
if se+sz=0 then goto seg2               Rem wenn Sekundeneiner+zehner =0 dann weiter
if se=0 then dec sz                     
if se=0 then let se=10                  
let se=se-1                             ' nicht negativ wird
if mz+me=0 then gosub out               Rem sub zum festellen ob 30 sek erreicht
let sekunde=0                           Rem Timer Reset
goto start

seg2:

let se=9
let sz=5
dec me
let me=me+1
if me=0 then goto seg1
let me=me-1
let sekunde=0
goto start

seg1:

dec mz
let me=9
let sekunde=0
goto start


ende:

let mz=holdmz                           Rem eingestellte Werte
let me=holdme                           Rem nach Ablauf
let sz=0                                Rem wieder
let se=0                                Rem bergeben
res Rc,7                                Rem D1 aus
goto einstellen



einstellen:

gosub anzeige
if Rc,4=0 then dec mz                   Rem warten auf Taste S51
let mz=mz+1
if mz=0 then let mz=10
let mz=mz-1
if Rc,4=0 then gosub prell
if Rc,5=0 then dec me                   Rem warten auf Taste S52
let me=me+1
if me=0 then let me=10
let me=me-1
if Rc,5=0 then gosub prell
if Ra,4=0 then goto start1              Rem warten auf Taste S33
goto einstellen

start1:

let sekunde=0                           Rem interner Zhler auf 0
let holdmz=mz                           Rem eingestellte Werte
let holdme=me                           '   speichern
goto start

out:

let hv=sz*10+se                          Rem sekundenzehner/einer
if hv=30 then set Rc,7                   '   addieren und D1
return                                   '   ab 30 sek einschalten

prell:

gosub anzeige                            Rem Tastenprellen von
if Rc,4=0 then goto prell                '   Minutenzehnertaster S51 und
if Rc,5=0 then goto prell                '   Minuteneinertaster  S52
return                                   '   eleminieren

end
